<script lang="ts">
    import type { Repository } from "$lib/types/githubResults.type";
    import DetailedViewDialog from "./DetailedViewDialog.svelte";
    import Result from "./Result.svelte";

    export let repositories: Repository[];

    let sortKey: string | undefined;
    let currentSelectedLanguage: string | undefined;

    $: programmingLanguages = countLanguages(repositories);
    $: filteredAndSortedRepositories = filterAndSort(
        repositories,
        currentSelectedLanguage,
        sortKey
    );

    let showLanguageDropdown = false;

    function toggleLanguageDropdown() {
        showLanguageDropdown = !showLanguageDropdown;
    }

    function countLanguages(repositories: Repository[]) {
        const languages = new Map<string, number>();
        repositories
            .map((repository) => repository.language)
            .forEach((language) => {
                // set language to Unknown when it is not a valid language
                if (language === undefined || language === null) {
                    language = "Unknown";
                }
                const count = languages.get(language);
                if (count === undefined) {
                    languages.set(language, 1);
                } else {
                    languages.set(language, count + 1);
                }
            });
        // sort alphabetically before returning
        return [...languages.entries()].sort((a, b) => {
            // Unknown is "greater" than every other language so that it is at the end of the list
            if (a[0] === "Unknown") return 1;
            if (a[0] < b[0]) return -1;
            else if (a[0] > b[0]) return 1;
            return 0;
        });
    }

    function filterAndSort(
        repositories: Repository[],
        filterBy: string | undefined,
        sortBy: string | undefined
    ) {
        if (filterBy === "Unknown") {
            repositories = repositories.filter(
                (repository) =>
                    repository.language === undefined ||
                    repository.language === null
            );
        } else if (filterBy !== undefined) {
            repositories = repositories.filter(
                (repository) => repository.language === filterBy
            );
        }

        if (sortBy !== undefined) {
            repositories.sort((a, b) => {
                const countB = b.amountPublications.get(sortBy) ?? 0;
                const countA = a.amountPublications.get(sortBy) ?? 0;
                if (countB === undefined || countA === undefined) return 0; // cannot compare, assume equal
                return countB - countA;
            });
        }

        // count total citations
        repositories.forEach((repository) => {
            repository.amountPublications.set(
                "total",
                [...repository.amountPublications.entries()]
                    .filter((publications) => publications[0] !== "total")
                    .reduce(
                        (publicationSum, currentValue) =>
                            publicationSum + currentValue[1],
                        0
                    )
            );
        });

        return repositories;
    }

    let sources = [
        { key: "zenodo", name: "Zenodo" },
        { key: "openAlex", name: "OpenAlex" },
        { key: "openCitations", name: "OpenCitations" },
        { key: "DataCite", name: "DataCite" },
        { key: "citationCff", name: "CitationCff" },
        { key: "total", name: "Total Citations" },
    ];

    let detailedViewRepository: Repository;
    let detailedViewOpen: boolean = false;
    const openDetailedView = (result: Repository) => {
        detailedViewRepository = result;
        detailedViewOpen = true;
    }
</script>

{#if detailedViewRepository !== undefined}
    {#key detailedViewRepository.name}
        <DetailedViewDialog bind:open={detailedViewOpen} result={detailedViewRepository} />
    {/key}
{/if}

<table class="w-full">
    <thead class="bg-gray-100 border-b-2 border-gray-200">
        <tr class="text-gray-700">
            <th />
            <th class="bg-gray-200 p-3" colspan="6">
                Citations (Click to Sort)
            </th>
            <th />
        </tr>
        <tr class="text-gray-700">
            <th class="w-96 p-3 text-m font-semibold tracking-wide text-left">
                Repository Name (Click to show Details)
            </th>
            {#each sources as source, i}
                <th
                    on:click={() => (sortKey = source.key)}
                    class="hover:cursor-pointer hover:underline hover:text-gray-900 p-3 text-center text-m font-semibold tracking-wide {i ===
                    0
                        ? 'border-l-2'
                        : i === sources.length - 1
                        ? 'border-r-2'
                        : ''}"
                >
                    {source.name}
                </th>
            {/each}
            <th class="w-52 p-3 text-m font-semibold tracking-wide text-left">
                <button
                    on:click={toggleLanguageDropdown}
                    class="hover:underline hover:cursor-pointer hover:text-gray-900"
                >
                    Languages (Select)
                </button>
                {#if showLanguageDropdown}
                    <div
                        class="absolute right-0 z-10 mt-2 w-56 origin-top-right rounded-md bg-white shadow-lg ring-1 ring-black ring-opacity-5 focus:outline-none"
                        role="menu"
                        aria-orientation="vertical"
                        aria-labelledby="menu-button"
                        tabindex="-1"
                    >
                        <div class="py-1">
                            <button
                                on:click={() =>
                                    (currentSelectedLanguage = undefined)}
                                on:click={toggleLanguageDropdown}
                                class="block w-full text-left text-gray-700 px-4 py-2 text-sm no-underline hover:bg-gray-200 hover:cursor-pointer"
                            >
                                All Languages ({programmingLanguages.reduce(
                                    (prev, curr) => prev + curr[1],
                                    0
                                )})
                            </button>
                            {#each programmingLanguages as [language, count]}
                                <button
                                    on:click={() =>
                                        (currentSelectedLanguage = language)}
                                    on:click={toggleLanguageDropdown}
                                    on:keypress
                                    class="block w-full text-left text-gray-700 px-4 py-2 text-sm no-underline hover:bg-gray-200 hover:cursor-pointer"
                                >
                                    {language} ({count})
                                </button>
                            {/each}
                        </div>
                    </div>
                {/if}
            </th>
        </tr>
    </thead>
    <tbody class="striped divide-y divide-gray-200" data-test="result-table">
        {#each filteredAndSortedRepositories as result}
            {#key result.name}
                <Result {result} {sources} openDetailedView={() => openDetailedView(result)} />
            {/key}
        {/each}
    </tbody>
</table>
